//
//  ProductListViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import Tabman
import Pageboy
import RxCocoa

protocol ProductListPresenterInterface: PresenterInterface {
    var addProductTrigger: PublishRelay<Void> { get }
}

final class ProductListViewController: TabmanViewController, ProductListViewInterface {
    
    var viewControllers = Array(repeating: 0, count: 4).indices.map { _ in ProductListPageWireframe().viewController }
    // MARK: - Public properties -
    
    var presenter: ProductListPresenterInterface!
    
    // MARK: - Lifecycle -
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        navigationItem.title = "Danh sản sản phẩm"
        navigationController?.hideShadowLine()
        
        navigationItem.rightBarButtonItem = UIBarButtonItem(
            title: "Thêm",
            style: .plain,
            target: self,
            action: #selector(didTapAddProductBarButton)
        )
    }
    
    @objc func didTapAddProductBarButton() {
        presenter.addProductTrigger.accept(())
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.dataSource = self
        let pagerTabbar = TMBarView.ButtonBar()
        pagerTabbar.backgroundColor = .clear
        
        // Customize bar properties including layout and other styling.
        pagerTabbar.layout.contentInset = UIEdgeInsets(top: 0.0, left: 16.0, bottom: 2.0, right: 16.0)
        pagerTabbar.layout.interButtonSpacing = 28.0
        pagerTabbar.indicator.weight = .light
        pagerTabbar.indicator.cornerStyle = .eliptical
        pagerTabbar.fadesContentEdges = true
        pagerTabbar.spacing = 16.0
        pagerTabbar.backgroundColor = Colors.white500
        
        // Set tint colors for the bar buttons and indicator.
        pagerTabbar.buttons.customize {
            $0.tintColor = Colors.ink400s
            $0.font = DS.T14M().font
            $0.selectedTintColor = Colors.red500
        }
        pagerTabbar.indicator.tintColor = Colors.red500
        
        addBar(pagerTabbar, dataSource: self, at: .top)
    }
    
}

// MARK: - Extensions -
extension ProductListViewController: PageboyViewControllerDataSource, TMBarDataSource {
    func numberOfViewControllers(in pageboyViewController: PageboyViewController) -> Int {
        return viewControllers.count
    }
    
    func viewController(for pageboyViewController: PageboyViewController, at index: PageboyViewController.PageIndex) -> UIViewController? {
        return viewControllers[index]
    }
    
    func defaultPage(for pageboyViewController: PageboyViewController) -> PageboyViewController.Page? {
        return nil
    }
    
    func barItem(for bar: TMBar, at index: Int) -> TMBarItemable {
        let title = "Category for \(index)"
                return TMBarItem(title: title)
    }
    
    
}
extension ProductListViewController {
}
